<script setup lang="ts">
  import { ListingFilter } from '@shopware-pwa/types';

  const emits = defineEmits<{
    (e: 'update:modelValue', value?: number): void;
  }>();

  const props = defineProps<{
    modelValue?: number;
    filter: ListingFilter;
  }>();

  const labelName = ref(props.filter.label);

  const scoreValue = ref<number | undefined>(0);

  const renderLabelName = () => {
    const extraText = scoreValue.value ? `(${scoreValue.value})` : '';
    labelName.value = `${props.filter.label} ${extraText}`;
  };

  const onChangeRating = () => {
    renderLabelName();
    emits('update:modelValue', scoreValue.value);
  };

  watch(
    () => props.modelValue,
    () => {
      if (scoreValue.value !== props.modelValue) {
        scoreValue.value = props.modelValue;
        renderLabelName();
      }
    },
  );
</script>

<template>
  <SwDropdownFiltering :label="labelName" :has-value="scoreValue && scoreValue > 0">
    <template #content>
      <div class="flex">
        <SwRating v-model="scoreValue" @change="onChangeRating" />
      </div>
    </template>
  </SwDropdownFiltering>
</template>
